/**
   \file
   \author Shin'ichiro Nakaoka
*/

#ifndef CNOID_BODYPLUGIN_OSG_SCENE_BODY_MANAGER_H_INCLUDED
#define CNOID_BODYPLUGIN_OSG_SCENE_BODY_MANAGER_H_INCLUDED

#include "BodyItem.h"
#include <cnoid/ExtensionManager>
#include "exportdecl.h"

namespace cnoid {

    class OSGSceneBody;
    class SBMImpl;

    class CNOID_EXPORT OSGSceneBodyManager
    {
      public:
        
        static OSGSceneBodyManager* instance();
        
        OSGSceneBodyManager(ExtensionManager& ext);
        ~OSGSceneBodyManager();

        OSGSceneBody* sceneBody(BodyItemPtr bodyItem);
            
        class FactoryHolder {
        public:
            virtual ~FactoryHolder() { }
        };
        
        FactoryHolder* addSceneBodyFactory(boost::function<OSGSceneBody*(BodyItem*)> factory);
        
      private:
        SBMImpl* impl;
    };
}

#endif
