/*!
  @file
  @author Shizuko Hattori
*/

#ifndef CNOID_BULLET_PLUGIN_BULLET_SIMULATOR_ITEM_H_INCLUDED
#define CNOID_BULLET_PLUGIN_BULLET_SIMULATOR_ITEM_H_INCLUDED

#include <cnoid/SimulatorItem>

namespace cnoid {

    class BulletSimulatorItemImpl;
        
    class BulletSimulatorItem : public SimulatorItem
    {
      public:

        static void initialize(ExtensionManager* ext);
        
        BulletSimulatorItem();
        BulletSimulatorItem(const BulletSimulatorItem& org);
        virtual ~BulletSimulatorItem();

        virtual void setAllLinkPositionOutputMode(bool on);

      protected:
        
        virtual SimulationBodyPtr createSimulationBody(const Body& orgBody);
        virtual bool initializeSimulation(const std::vector<SimulationBodyPtr>& simBodies);
        virtual void initializeSimulationThread();
        virtual bool stepSimulation(const std::vector<SimulationBodyPtr>& activeSimBodies);
        
        virtual ItemPtr doDuplicate() const;
        virtual void doPutProperties(PutPropertyFunction& putProperty);
        virtual bool store(Archive& archive);
        virtual bool restore(const Archive& archive);

      private:
        BulletSimulatorItemImpl* impl;
        friend class BulletSimulatorItemImpl;
    };

    typedef boost::intrusive_ptr<BulletSimulatorItem> BulletSimulatorItemPtr;
}

#endif
